<?php // Simple Générateur IHM pour base de données MySQL ©PCo2007
      // Contrôleur pour le générateur d'applications
      
include("../bibliotheques/_htmlModele.inc.php");
define("HTML", htmlCharger("generer.html"));

function creerDossier($chemin) {
  if (file_exists($chemin)) {
    $dir=opendir($chemin);
    while($fichier=readdir($dir)) {
      if (($fichier!=".")&&($fichier!="..")) unlink("$chemin/$fichier");
    }
  }
  else mkdir($chemin);
}

function ajouterAvecSeparateur(&$var, $sep, $ajout) {
  if ($var!="") $var.=$sep;
  $var.=$ajout;
}

function fusionnerModeleDonnees($base, $source, $destination, $params) {
  $modele=file_get_contents($source);
  foreach($params as $cle=>$valeur) {
      $modele=str_replace("#$cle#", $valeur, $modele);  
  }
  $id = fopen("../applications/$base/$destination", 'w');
  fwrite($id, $modele);
  fclose($id);
}

function creerVueCtrl($base, $table, $connexion) {
  $ctrl=array("table"=>"$table", "champs"=>"", "get_pk"=>"", "where_pk"=>"", "where_pki"=>"", "values"=>"", "set"=>"");
  $vue=array("table"=>"$table", "champs_th"=>"", "champs_td"=>"", "champs_input"=>"", "param_pk"=>"");

  $extraitLE=htmlExtraire(MODELE, "listeEntete");
  $extraitLD=htmlExtraire(MODELE, "listeDetail");
  $extraitSD=htmlExtraire(MODELE, "saisieDebut");
  $extraitSN=htmlExtraire(MODELE, "saisieNULL");
  $extraitSF=htmlExtraire(MODELE, "saisieFin");
  $extraitPKI=htmlExtraire(MODELE, "saisiePKI");
         
  $resultat=mysql_query("describe $table", $connexion);
  while($colonne=mysql_fetch_array($resultat)) {
    $type=$colonne['Type'];
    if (preg_match("#\((.*)\)#isU", $type, $size)) {
      $size=$size[1];
      if ($size>30) $size=30; // maxi !
    }
    else {
      $size=10; // par défaut
    }
    if (strstr($type, "char")||strstr($type, "text")||
        strstr($type, "date")||strstr($type, "time")) {
      $filtre="fs"; // caractère
    }
    else {
      $filtre="fn"; // numérique
    }
    $nom=$colonne['Field'];
    if ($colonne["Key"]=="PRI") {
      ajouterAvecSeparateur($ctrl["where_pk"], " AND ", "$nom='\$$nom'");
      ajouterAvecSeparateur($ctrl["where_pki"], " AND ", "$nom='\${$nom}_pki'");
      ajouterAvecSeparateur($ctrl["get_pk"], "; ", "\$$nom=\$_GET['$nom']"); 
      ajouterAvecSeparateur($vue["param_pk"], "&", "$nom=\$$nom");
    }
    ajouterAvecSeparateur($ctrl["values"], ", ", "'\$$nom'");
    ajouterAvecSeparateur($ctrl["champs"], ", ", "'$nom'");
    ajouterAvecSeparateur($ctrl["set"], ", ", "$nom='\$$nom'");
    
    $largTH=intval($size/1.5)+1;
    eval(htmlVar($extraitLE, "res")); $vue["champs_th"].=$res;
    eval(htmlVar($extraitLD, "res")); $vue["champs_td"].=$res;
    
    $saisieNULL="";
    if ($colonne['Null']=="YES") eval(htmlVar($extraitSN, "saisieNULL"));
    eval(htmlVar($extraitSD, "sd"));
    eval(htmlVar($extraitSF, "sf"));
    $vue["champs_input"].=$sd.$saisieNULL.$sf;
    if ($colonne["Key"]=="PRI") {
      eval(htmlVar($extraitPKI, "pki"));
      $vue["champs_input"].=$pki.$sf;
    }
  }
  fusionnerModeleDonnees($base, "modeles/_controleur.php", "{$table}.php", $ctrl);
  fusionnerModeleDonnees($base, "modeles/_vue.html", "{$table}.html", $vue);
}

// début >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
if (isset($_GET["action"])) $action=$_GET["action"];
else $action="saisir";

switch ($action) {
  case "saisir" :
    $serveur="localhost";
    $utilisateur="root";
    $motDePasse="";
    if (count($_POST)!=0) extract($_POST);
    @$connexion = mysql_connect($serveur, $utilisateur, $motDePasse);
    eval(htmlEcho(HTML, ""));
    eval(htmlEcho(HTML, "formDebut"));
    if ($connexion) {
      $bases = mysql_list_dbs($connexion);
      while ($base = mysql_fetch_assoc($bases)) {
        $base=$base["Database"];
        eval(htmlEcho(HTML, "base"));
      }
    }
    else {
      eval(htmlEcho(HTML, "baseNon"));
    }
    eval(htmlEcho(HTML, "baseFin"));
    if ($connexion) eval(htmlEcho(HTML, "ok"));
    eval(htmlEcho(HTML, "formFin"));
    if (!$connexion) eval(htmlEcho(HTML, "errConnexion"));
    eval(htmlEcho(HTML, "fin"));
    break;
    
  case "valider" :
    extract($_POST);
    @$connexion = mysql_connect($serveur, $utilisateur, $motDePasse);
    if (!$connexion) {
      eval(htmlEcho(HTML, ""));
      eval(htmlEcho(HTML, "errConnexion"));      
      eval(htmlEcho(HTML, "fin"));
      exit();
    }
    @$bd = mysql_select_db($base, $connexion);
    if (!$bd) {
      eval(htmlEcho(HTML, ""));
      eval(htmlEcho(HTML, "errBase")); 
      eval(htmlEcho(HTML, "fin"));
      exit();
    }
    if ($connexion && $bd) {
      define("MODELE", htmlCharger("modeles/_commun.html"));
      creerDossier("../applications/$base");
      $listeTables="";
      $tables = mysql_list_tables($base, $connexion);
      $extrait=htmlExtraire(MODELE, "listeTables");
      while ($table = mysql_fetch_array($tables)) {
        $table=$table[0];
        creerVueCtrl($base, $table, $connexion);
        eval(htmlVar($extrait, "res"));
        $listeTables.=$res;
      }
      fusionnerModeleDonnees($base, "modeles/_index.html", "index.html", array("base"=>$base));
      fusionnerModeleDonnees($base, "modeles/_menu.html", "menu.html", array("base"=>$base, "listeTables"=>$listeTables));
      fusionnerModeleDonnees($base, "modeles/_config_base.php", "config_base.php",
        array("serveur"=>$serveur, "base"=>$base, "utilisateur"=>$utilisateur, "motDePasse"=>$motDePasse, "encodage"=>"latin1"));
    }
    header("location: ../applications/$base");
    break;
}

?>
